CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 5_000_000
   
OBJ
  tch:           "Touch"                                 ' touchscreen driver
'  F          : "FloatMath"                 'From Parallax Inc. v1.0
  Q          : "SPIN_TrigPack"             'v2.0 CompElit Ltd.
    psg : "PropellerSignalGenerator"                    ' thanks to Ahle2

VAR


PUB Main
   tch.BeginProgram                                        
  Function
  tch.SetWarmBoot                                           ' clears screen, sets a warm boot and reboots

PUB Function | xval,yval,org_x,org_y,pointx,pointy,r,theta,a,switchx,switchy,frequency,font,range,slider,xslider,yslider,waveform
    psg.start(21, 23)                                   ' two audio pins (not next to each other so less crosstalk)
    frequency := 440
    range := 1                                          ' x10, x100 etc
    slider := 44                                        ' 0-255
    xslider := 26                                       ' position of the slider
    yslider := 144
    waveform := 21                                       ' waveform SAW = 18, TRIANGLE = 21, SQUARE = 24, NOISE = 27,                                    
    tch.ClearRam                                        ' clear all but file 0 and 1
    tch.StringDim(10)                                   ' file 2 = strings if needed
    tch.SDBMPtoRam(string("function.bmp"))              ' file 3
    tch.SDBMPtoRam(string("rot1.bmp"))                  ' file 4
    tch.SDBMPtoRam(string("rot2.bmp"))                  ' file 5
    tch.SDBMPtoRam(string("rot3.bmp"))                  ' file 6
    tch.SDBMPtoRam(string("rot4.bmp"))                  ' file 7
    font := tch.Loadfont(string("DSdigGr.ifn"))         ' file 8
    tch.SDBMPtoRam(string("SlideP.bmp"))                ' file 9 slider
    tch.SDBMPtoRam(string("synknbp.bmp"))               ' file 10 slider knob
    tch.SDBMPtoRam(string("synoffP.bmp"))               ' file 11 switch off
    tch.SDBMPtoRam(string("synonP.bmp"))                ' file 12 slider knob
    tch.DrawBMPRam(3,0,0)                               ' draw file 3
    DrawSlider(xslider,yslider,slider,9)   
    LCDPrintFrequency(frequency,font)                   ' clear the little LCD display and print frequency
    RedrawSwitches(waveform)                            ' redraw the switches
    switchx := 138                                      ' centre of the switch, not the top left
    switchy := 171                                      ' switch bitmap is 60x60
    tch.DrawBMPRam(4,switchx-30,switchy-30)             ' draw file 4
    RefreshSound(waveform,frequency)  
    tch.SelectSPIGroup                                  ' talk to the spi touchscreen
    repeat
      yval := tch.TouchYPercent                         ' decode yval 0-100%               
      xval := tch.TouchXPercent                         ' decode xval 0-100%
      if (xval <> 255)  and (yval <> 255)               ' valid keypress
         xval := (xval*24)/10                           ' 0-240, use portrait mode 
         yval := (yval*32)/10                           ' 0-320
         'tch.hex(xval,2)
         'tch.hex(yval,2)
         org_x := q.Qval(switchx)                       ' origin x of the switch
         org_y := q.Qval(switchy)                       ' origin y
         pointx := q.Qval(xval)                         ' point touched
         pointy := q.Qval(yval)                         ' point touched
         r := q.Qradius(pointx - org_x, pointy - org_y)
         'tch.text(Q.QvalToStr(r))                      ' debugging
         theta := Q.Deg_ATAN2(pointx - org_x, org_y - pointy)     ' pointy and orgy swapped as 0,0 is top left of the screenpolar coordinates with correct sign
         'tch.text(Q.QvalToStr(theta))  
         theta += q.Qval(180)                           ' rotate 180 degrees and remove negative numbers, 0=9 o'clock, 90=6 o'clock, 180 = 3 o'clock, 270 = 12 o'clock
         'tch.hex(r >> 16,2)
         if (r >> 16) < 47                              ' touch close to the switch
           case (theta >> 16)
             0..90: tch.DrawBMPRam(4,switchx-30,switchy-30)                  ' draw switch position 1
                    range := 1
             91..180:tch.DrawBMPRam(7,switchx-30,switchy-30)                 ' draw switch position 4
                    range := 1000
             181..270:tch.DrawBMPRam(6,switchx-30,switchy-30)                ' draw switch position 3
                    range := 100
             271..359:tch.DrawBMPRam(5,switchx-30,switchy-30)                ' draw switch position 2
                    range := 10
           frequency := RecalcFrequency(slider,range,frequency,font,waveform)        ' redraw the display
         'tch.text(Q.QvalToStr(theta))                  ' debugging

         if xval >60 and xval <119 and yval >220 and yval <250     ' -1 frequency button
           frequency +=1
           LCDPrintFrequency(frequency,font)
           RefreshSound(waveform,frequency)     
         if xval >120 and xval <180 and yval >220 and yval <250    ' +1 frequency button      
           frequency -=1
           LCDPrintFrequency(frequency,font)
           RefreshSound(waveform,frequency)     
         if xval > xslider and xval <60 and yval >yslider and yval <212      ' slider 26,144
           slider := yval - yslider                                          ' position on slider
           slider := slider * 256                                            ' 69 pixels high convert to 0-255
           slider := slider / 69
           if slider > 255
             slider := 255
           if slider < 0
             slider := 0
           tch.SelectMemGroup
           DrawSlider(xslider,yslider,slider,9)                                   ' redraw this slider
           frequency := RecalcFrequency(slider,range,frequency,font,waveform)             ' redraw the display
         if yval >58 and yval < 114                     ' one of the 4 switches
           case xval
             25..59:waveform := 18                      ' sawtooth
             77..110:waveform := 21                     ' triangle
             129..162:waveform := 24                    ' square
             181..214:waveform := 27                    ' noise
           RecalcFrequency(slider,range,frequency,font,waveform) ' refresh display and output sound
           RedrawSwitches(waveform)                                       
         if xval >190 and xval <240 and yval>0 and yval <40 ' off button
           return
         
         tch.pause1ms(100) ' debounce delay  
         tch.SelectSPIGroup

PUB DrawSlider(x,y,value,filen)                              ' value is 0-255. assumes bitmaps in ram
    tch.DrawBMPRam(filen,x,y)                               ' draw background
    tch.DrawBMPRam(filen+1,x+5,y+((value*100)/450))           ' draw the knob

PUB LCDPrintFrequency(frequency,font)
     tch.ClearRectangle(41,265,197,307,tch.GetBackFontColor) ' clear an area the same color as the font background   
     tch.SetCursor(46,267)
     tch.StringStr(0,frequency)                    ' store frequency to string zero
     tch.StringPrint(font,0)

PUB RecalcFrequency(slider,range,frequency,font,waveform)
    frequency := slider * 4 * range        ' slider 0-255, first range is 0-1000 Hz
    LCDPrintFrequency(frequency,font)
    RefreshSound(waveform, frequency)
    result := frequency

PUB RefreshSound(waveform,frequency)
    if waveform <> 24                                   ' not square
      psg.setParameters(waveform, frequency, 1, 0)      ' output the sound
    else
      psg.setParameters(waveform, frequency, 1, 1<<31)  ' square 50%       

PUB RedrawSwitches(waveform) ' SAW = 18, TRIANGLE = 21, SQUARE = 24, NOISE = 27
    tch.SelectMemGroup
    tch.DrawBMPRam(11,25,59) ' draw all switches off first
    tch.DrawBMPRam(11,77,59)    
    tch.DrawBMPRam(11,129,59)
    tch.DrawBMPRam(11,181,59)
    case waveform
      18:tch.DrawBMPRam(12,25,59)     ' switch on
      21:tch.DrawBMPRam(12,77,59)
      24:tch.DrawBMPRam(12,129,59)
      27:tch.DrawBMPRam(12,181,59)   